<?php
/*$Id: gaziecart.php,v 1.10 2010/12/18 09:16:49 devincen Exp $
 --------------------------------------------------------------------------
                            Gazie - Gestione Azienda
    Copyright (C) 2004-2010 - Antonio De Vincentiis Montesilvano (PE)
                                (www.devincentiis.it)
                        <http://gazie.sourceforge.net>
 --------------------------------------------------------------------------
    Questo programma e` free software;   e` lecito redistribuirlo  e/o
    modificarlo secondo i  termini della Licenza Pubblica Generica GNU
    come e` pubblicata dalla Free Software Foundation; o la versione 2
    della licenza o (a propria scelta) una versione successiva.

    Questo programma  e` distribuito nella speranza  che sia utile, ma
    SENZA   ALCUNA GARANZIA; senza  neppure  la  garanzia implicita di
    NEGOZIABILITA` o di  APPLICABILITA` PER UN  PARTICOLARE SCOPO.  Si
    veda la Licenza Pubblica Generica GNU per avere maggiori dettagli.

    Ognuno dovrebbe avere   ricevuto una copia  della Licenza Pubblica
    Generica GNU insieme a   questo programma; in caso  contrario,  si
    scriva   alla   Free  Software Foundation,  Inc.,   59
    Temple Place, Suite 330, Boston, MA 02111-1307 USA Stati Uniti.
 --------------------------------------------------------------------------
*/
/**
 * GAzieCart Model for GAzie Cart Component
 *
 * @package    Joomla.Tutorials
 * @subpackage Components
 * @link http://dev.joomla.org/component/option,com_jd-wiki/Itemid,31/id,tutorials:components/
 * @license     GNU/GPL
 */

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die();

jimport( 'joomla.application.component.model' );

/**
 * GAzieCart Model
 *
 * @package    Joomla.Tutorials
 * @subpackage Components
 */
class GAzieCartModelGAzieCart extends JModel
{
    function getUserState($name,$def=null) {
        $app = JFactory :: getApplication();
        $context = 'com_gaziecart.gaziecart.';
        $session =& JFactory::getSession();
        return $app->getUserStateFromRequest($context.$name,$name,$session->get("FirstGroup"));
    }

    function getTaxRate()
    {
        $db =& JFactory::getDBO();
        $query = "SELECT val FROM #__gaziecart WHERE var ='tax' ";
        $db->setQuery( $query );
        $head_msg = $db->loadResult();
        return $head_msg;
    }

    function getTopMessage()
    {
        $db =& JFactory::getDBO();
        $query = "SELECT val FROM #__gaziecart WHERE var ='head' ";
        $db->setQuery( $query );
        $head_msg = $db->loadResult();
        return $head_msg;
    }

    function getFootMessage()
    {
        $db =& JFactory::getDBO();
        $query = "SELECT val FROM #__gaziecart WHERE var ='foot' ";
        $db->setQuery( $query );
        $foot_msg = $db->loadResult();
        return $foot_msg;
    }

    function getProduct()
    {
    // uso le sessioni per non rileggere il file ogni volta
    $session =& JFactory::getSession();
    $prod_data = $session->get("Product");

    // annullo un eventuale ordine in sessione per permettere la modifica
    $session->set("cart_data",'');

    $product=array();
    if (empty($prod_data)){ // al primo accesso
        $xml = new JSimpleXML;
        $xml->loadFile(JPATH_COMPONENT.DS.'gaziecart.xml');
        $all_product=array();
        //carico nella variabile di sessione  tutti i prodotti
        foreach ($xml->document->artico as $articolo){
                $all_product[$articolo->codice[0]->_data]['codice']=$articolo->codice[0]->_data;
                $all_product[$articolo->codice[0]->_data]['catmer']=$articolo->catmer[0]->_data;
                $all_product[$articolo->codice[0]->_data]['descri']=$articolo->descri[0]->_data;
                $all_product[$articolo->codice[0]->_data]['unimis']=$articolo->unimis[0]->_data;
                $all_product[$articolo->codice[0]->_data]['prezzoweb']=$articolo->prezzoweb[0]->_data;
                $all_product[$articolo->codice[0]->_data]['taxrate']=$articolo->taxrate[0]->_data;
                if ( file_exists ('components/com_gaziecart/images/artico/'.$articolo->codice[0]->_data.'.png') ) {
                      $all_product[$articolo->codice[0]->_data]['image']='components/com_gaziecart/images/artico/'.$articolo->codice[0]->_data.'.png';
                } else {
                      $all_product[$articolo->codice[0]->_data]['image']='components/com_gaziecart/images/artico/DEFAULT.png';
                }
                $all_product[$articolo->codice[0]->_data]['url']=$articolo->url[0]->_data;
                $all_product[$articolo->codice[0]->_data]['annota']=$articolo->annota[0]->_data;
        }
        $session->set("Product",$all_product);
      } else {
        $all_product=$session->get("Product");
      }
      foreach ($all_product as $k=>$only_group){
          if ( $only_group['catmer'] == $this->getUserState('group_code') ||
               $this->getUserState('group_code') == 100 ) {
               $product[$k]=$only_group;
          }
      }
      return $product;
    }

    function getGroup()
    {
    // uso le sessioni per non rileggere il file ogni volta
    $session =& JFactory::getSession();
    $group_data = $session->get("Group");
    if (empty($group_data)){ // al primo accesso
        $xml = new JSimpleXML;
        $xml->loadFile(JPATH_COMPONENT.DS.'gaziecart.xml');
        $option=array();
        $first=true;
        foreach ($xml->document->catmer as $catmer) {
            if ($first) {
               $first_cm=$catmer->codice[0]->_data;
               $first=false;
            }
            $option[$catmer->codice[0]->_data]=JHTML::_('select.option', $catmer->codice[0]->_data,$catmer->descri[0]->_data,'codice','descri');
        }
        //aggiungo il valore "tutto"
        $option[100]=JHTML::_('select.option','100','&laquo;TUTTE&raquo;','codice','descri');
        $session->set("Group",$option);
        $session->set("FirstGroup",$first_cm);
    } else {
        $option=$session->get("Group");
    }
    return $option;
    }
}